unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, Forms, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    ComboBox1: TComboBox;
    procedure Button1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  comobj, SysUtils, Printers;

var
  formularPrinter : integer = 0;

{ TForm1 }


procedure TForm1.Button1Click(Sender: TObject);
var
  vMSWord       : variant;
  vWDocument    : variant;
  FileName      : OLEVariant;
begin
  try
    FileName:=extractfilepath(ParamStr(0))+'Test.docx';

    vMSWord    := CreateOleObject('Word.Application');
    vWDocument := vMSWord.Documents.Open(FileName);

    vMSWord.ActivePrinter := Printer.Printers[formularPrinter]; // Funktioniert nicht
    //vMSWord.Application.ActivePrinter := Printer.Printers[formularPrinter];   // Funktioniert ebenso wenig

    vMSWord.ActiveDocument.PrintOut(false);

    vWDocument.Close(0);
    vMSWord.Quit;
    vMSWord := Unassigned;

  except
    Application.MessageBox('Formular konnte nicht gedruckt werden','Word-Fehler',16);
  end;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
var
  i: integer;
begin
  for i:=0 to ComboBox1.Items.Count-1 do
  begin
    if ComboBox1.Text = ComboBox1.Items[i] then formularPrinter:=i ;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   ComboBox1.Items:=Printer.Printers;
   ComboBox1.Text:=ComboBox1.Items[0];
end;



end.

